Claw_Resources = {}

local gcdSpell
if select(2, UnitClass("player")) == "ROGUE" then
	gcdSpell = 1752 -- Sinister Strike
elseif select(2, UnitClass("player")) == "DRUID" then
	gcdSpell = 1082 -- Claw
else
    DisableAddOn("Claw_Resources")
    return
end

SLASH_Claw_Resources1, SLASH_Claw_Resources2 = "/clawres", "/cres"

local function InitializeVariables()
	Claw_Resources.locked = Claw_Resources.locked == nil and false or Claw_Resources.locked
	Claw_Resources.scale = Claw_Resources.scale == nil and 1 or Claw_Resources.scale
	Claw_Resources.frequency = Claw_Resources.frequency == nil and 0.01 or Claw_Resources.frequency
	Claw_Resources.cpalert = Claw_Resources.cpalert == nil and 5 or Claw_Resources.cpalert
end

local events, comboPoints = {}, {}
local lastUpdate, lastComboPoints = 0, 0
local backDrop = {
    bgFile = "Interface\\Addons\\Claw_Resources\\white16x16",
    edgeFile = "Interface\\Addons\\Claw_Resources\\white16x16",
    edgeSize = 1,
    tile = true,
    tileSize = 16
}
local updaterFrame = CreateFrame("Frame", nil, UIParent)
updaterFrame:SetPoint("TOPLEFT", -1, 1)
updaterFrame:SetSize(0, 0)
local comboPointFrame = CreateFrame("Frame", "Claw_ComboPointFrame", UIParent)
comboPointFrame:SetFrameStrata("BACKGROUND")
comboPointFrame:SetPoint("CENTER", 0, -222)
comboPointFrame:SetSize(168, 11)
comboPointFrame:RegisterForDrag("LeftButton")
comboPointFrame:SetScript("OnDragStart", comboPointFrame.StartMoving)
comboPointFrame:SetScript("OnDragStop", comboPointFrame.StopMovingOrSizing)
comboPointFrame:SetMovable(true)
comboPointFrame:Hide()
local energyFrame = CreateFrame("Frame", "Claw_EnergyFrame", UIParent)
energyFrame:SetFrameStrata("BACKGROUND")
energyFrame:SetPoint("TOPLEFT", comboPointFrame, "BOTTOMLEFT", 0, -3)
energyFrame:SetSize(168, 11)
energyFrame:SetBackdrop(backDrop)
energyFrame:SetBackdropColor(0, 0, 0, 0.4)
energyFrame:SetBackdropBorderColor(0, 0, 0, 0.6)
energyFrame:Hide()
local energyBar = CreateFrame("Frame", nil, energyFrame)
energyBar:SetFrameStrata("BACKGROUND")
energyBar:SetPoint("LEFT", 1, 0)
energyBar:SetHeight(9)
energyBar:SetBackdrop(backDrop)
energyBar:SetBackdropColor(0.7, 0.7, 0, 1)
energyBar:SetBackdropBorderColor(0.8, 0.8, 0.1, 1)
local energyText = energyBar:CreateFontString(nil, "OVERLAY")
energyText:SetFont("Fonts\\FRIZQT__.TTF", 8, "")
energyText:SetShadowOffset(1, -1)
energyText:SetShadowColor(0, 0, 0, 0.8)
energyText:SetPoint("CENTER", energyFrame)
local gcdFrame = CreateFrame("Frame", "Claw_GCDFrame", UIParent)
gcdFrame:SetFrameStrata("BACKGROUND")
gcdFrame:SetPoint("BOTTOMLEFT", comboPointFrame, "TOPLEFT", 0, 3)
gcdFrame:SetHeight(4)
gcdFrame:SetBackdrop(backDrop)
gcdFrame:SetBackdropColor(0, 0, 0, 0.4)
gcdFrame:SetBackdropBorderColor(0, 0, 0, 0.6)
gcdFrame:Hide()

local function UpdateComboPointBar()
    local points = GetComboPoints("player", "target")
    for i = 1, 5 do
        comboPoints[i]:SetBackdropColor(0, 0, 0, 0.6)
        comboPoints[i]:SetBackdropBorderColor(0, 0, 0, 0.4)
        if points >= i then
            comboPoints[i]:SetBackdropColor(0.6, 0, 0, 1)
            comboPoints[i]:SetBackdropBorderColor(0.8, 0.8, 0.1, 1)
            if Claw_Resources.cpalert > 0 and i == Claw_Resources.cpalert and lastComboPoints == i - 1 then
                PlaySoundFile("Interface\\Addons\\Claw_Resources\\sounds\\" .. math.random(1, 11) .. ".mp3", "Master")
            end
        end
    end
    lastComboPoints = points
end

local function UpdateEnergyBar()
	local energy = UnitPower("player", 3)
	if energy == 0 then
		energyBar:DisableDrawLayer("BACKGROUND")
		energyBar:DisableDrawLayer("BORDER")
	else
		energyBar:SetWidth(166 * (energy / UnitPowerMax("player", 3)))
		energyBar:EnableDrawLayer("BACKGROUND")
		energyBar:EnableDrawLayer("BORDER")
	end
	energyText:SetText(energy .. "/" .. UnitPowerMax("player", 3))
end

local function UpdateGCDBar()
	local gcdStart, gcdDuration = GetSpellCooldown(gcdSpell)
	if gcdStart ~= 0 then
		gcdFrame:SetWidth(168 - 168 * ((GetTime() - gcdStart) / gcdDuration))
		gcdFrame:EnableDrawLayer("BACKGROUND")
		gcdFrame:EnableDrawLayer("BORDER")
	else
		gcdFrame:DisableDrawLayer("BACKGROUND")
		gcdFrame:DisableDrawLayer("BORDER")
	end
end

function events:UNIT_COMBO_POINTS()
    UpdateComboPointBar()
end

function events:ADDON_LOADED(name)
	if name == "Claw_Resources" then
		InitializeVariables()
		comboPointFrame:SetScale(Claw_Resources.scale)
		energyFrame:SetScale(Claw_Resources.scale)
		gcdFrame:SetScale(Claw_Resources.scale)
		for i = 1, 5 do
			comboPoints[i] = CreateFrame("Frame", nil, comboPointFrame)
			comboPoints[i]:SetFrameStrata("BACKGROUND")
			comboPoints[i]:SetSize(32, 11)
			comboPoints[i]:SetPoint("LEFT", comboPointFrame, "LEFT", (i - 1) * 34, 0)
			comboPoints[i]:SetBackdrop(backDrop)
		end
		comboPointFrame:EnableMouse(not Claw_Resources.locked)
	end
end

updaterFrame:SetScript("OnUpdate", function(self, elapsed)
    lastUpdate = lastUpdate + elapsed
    if lastUpdate >= Claw_Resources.frequency then
		if UnitCanAttack("player", "target") then
			comboPointFrame:Show()
			energyFrame:Show()
			gcdFrame:Show()
			UpdateComboPointBar()
			UpdateEnergyBar()
			UpdateGCDBar()
		else
			comboPointFrame:Hide()
			energyFrame:Hide()
			gcdFrame:Hide()
		end
        lastUpdate = 0
    end
end)

updaterFrame:SetScript("OnEvent", function(self, event, ...) events[event](self, ...) end)
for k in pairs(events) do
    updaterFrame:RegisterEvent(k)
end

function SlashCmdList.Claw_Resources(msg, editbox)
    msg = { strsplit(" ", strlower(msg)) }
	if msg[1] == "locked" then
        if msg[2] then Claw_Resources.locked = msg[2] == "on" end
        comboPointFrame:EnableMouse(not Claw_Resources.locked)
        print("Claw Resources - Locked: " .. (Claw_Resources.locked and "|cFF00C000On" or "|cFFC00000Off"))
	elseif msg[1] == "scale" then
        if msg[2] then
			Claw_Resources.scale = tonumber(msg[2]) or 1
			comboPointFrame:SetScale(Claw_Resources.scale)
			energyFrame:SetScale(Claw_Resources.scale)
			gcdFrame:SetScale(Claw_Resources.scale)
		end
		print("Claw Resources - Scale: |cFFFFD000" .. Claw_Resources.scale .. "|r times")
	elseif msg[1] == "frequency" then
		Claw_Resources.frequency = tonumber(msg[2]) or 0.01
		print("Claw Resources - Update frequency: Every |cFFFFD000" .. Claw_Resources.frequency .. "|r seconds")
	elseif msg[1] == "cpalert" then
		if msg[2] then Claw_Resources.cpalert = msg[2] == "off" and 0 or tonumber(msg[2]) or 5 end
		print("Claw Resources - Alert at: " .. (Claw_Resources.cpalert > 0 and "|cFFFFD000" .. Claw_Resources.cpalert .. "|r combo points" or "|cFFC00000Never"))
    elseif msg[1] == "reset" then
		comboPointFrame:ClearAllPoints()
        comboPointFrame:SetPoint("CENTER", 0, -222)
		energyFrame:ClearAllPoints()
		energyFrame:SetPoint("TOPLEFT", comboPointFrame, "BOTTOMLEFT", 0, -3)
		gcdFrame:ClearAllPoints()
		gcdFrame:SetPoint("BOTTOMLEFT", comboPointFrame, "TOPLEFT", 0, 3)
		print("Claw Resources - Position has been reset to default")
    else
		print("Claw Resources (version: |cFFFFD000" .. GetAddOnMetadata("Claw_Resources", "Version") .. "|r) - Commands:")
	    print("  /cres locked |cFF00C000on|r/|cFFC00000off|r - lock the Claw Resources frame so that it can't be moved")
		print("  /cres scale |cFFFFD000[number]|r - set the scale of the Claw Resources UI (default is 1.0 times)")
		print("  /cres frequency |cFFFFD000[number]|r - set the calculation frequency (default is every 0.01 seconds)")
        print("  /cres reset - reset the location of Claw Resources to default")
        print("  /cres cpalert |cFFFFD000[#combo points]|r/|cFFC00000off|r - enable/disable the sound effect alert at combo points")
    end
end
